//--------------------------------------------------------------------//
// vl^E

var starsModel;			// f[^f
var viewModel;			// \f
var globe;			// Cݐf[^
var epoch;			// EX
var currentDate;		// ݓ
var julianDay;			// EX
var pressedButtons;		// ꂽ}EX{^
var mouse;			// }EXʒu
var clock;			// v
var modal;			// [_EBhE

var EPOCH_JD=2440587.5;		// 1970 N 1  1  00:00:00 GMT ̃EX
var MJD_EPOCH=2400000.5;	// EX̊_
var SIDEREAL0=0.67239;		// P
var DAY_RATIO=1.00273781;	// z^P
var SIDEREAL_EPOCH=2440000.5;	// P̊_
var MILLIS_TO_DAY=1.0/8.64E7;	// Ԃ~b֕ϊW
var DEAULT_EPOCH=2451545;	// ftHg̊EX
var TO_RADIAN=Math.PI/180.0;	// pxWAɕϊW

var FONT_SIZE=15;			// tHgTCY
var FONT=FONT_SIZE+"px 'Arial'";	// tHg
var FG_COLOR='#ffffff';			// OiF
var BG_COLOR='#000000';			// wiF

var CONSTE_WINDOW=0;			// EBhE
var GLOBE_WINDOW=1;			// ϑn_EBhE
var CALENDAR_WINDOW=2;			// J_[EBhE
var CLOCK_WINDOW=3;			// EBhE

// vl^E
// starsFileName - f[^t@C
// mapFileName - Cݐf[^t@C
// lx,ly - ox,ܓx
function initPlanetarium(starsFileName,mapFileName,lx,ly){
  starsModel=new StarsModel();
  globe=new GlobeMap(lx,ly);
  epoch=DEAULT_EPOCH;
  mouse=new THREE.Vector2();
  clock=new Clock();
  currentDate=new Date();
  currentDate.setTime(currentDate.getTime()+2.4e5*lx);
  julianDay=EPOCH_JD+MILLIS_TO_DAY*currentDate.getTime();
  document.getElementById('digitalclock').textContent=dateString();
  readDataFile(starsFileName,readStarsData);
  readDataFile(mapFileName,readMapData);
  viewModel=new ViewModel('planetarium-canvas');
  starsModel.createObjects();
  starsModel.setSkyColor();
  viewModel.initMouseEvent();
  modal=[document.getElementById('constellation'),
      	 document.getElementById('globe'),
      	 document.getElementById('calendar'),
      	 document.getElementById('clock')];
  loop();
}

// [v֐
var step=0;
function loop(){
  step++;
  viewModel.update();
  requestAnimationFrame(loop);
}

// v[gԂ
// text - \镶
function textPlate(text){
  var elem=document.createElement('div');
  elem.style.font=FONT;
  elem.style.color=FG_COLOR;
  elem.style.backgroundColor=BG_COLOR;
  elem.style.top='-0.5em';
  elem.style.left=(0.25*text.length)+'em';
  elem.textContent=text;
  return new THREE.CSS2DObject(elem);
}

// Ԃ𓮂
// dt - Ԉړ
function moveTime(dt){
  currentDate.setTime(currentDate.getTime()+dt);
  setTime();
}

// Ԃݒ肷
function setTime(){
  julianDay=EPOCH_JD+MILLIS_TO_DAY*currentDate.getTime();
  viewModel.setLocale();
  starsModel.setPlanetPosition();
  document.getElementById('digitalclock').textContent=dateString();
}

// Ԃ
function dateString(){
  return currentDate.getUTCFullYear()+'/'
      	+('0'+(currentDate.getUTCMonth()+1)).slice(-2)+'/'
      	+('0'+currentDate.getUTCDate()).slice(-2)+' '
      	+('0'+currentDate.getUTCHours()).slice(-2)+':'
      	+('0'+currentDate.getUTCMinutes()).slice(-2)+':'
      	+('0'+currentDate.getUTCSeconds()).slice(-2);
}

// [_EBhE
function hideModals(){
  for(var i=0;i<modal.length;i++) modal[i].style.zIndex=1;
}

// pNX쐬
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}

//--------------------------------------------------------------------//
// f[^f
var StarsModel=function(){
  this.stars=[];		// PE_
  this.starsMap={};
  this.planets=[];		// f
  this.saterites=[];		// q
  this.constellations=[];	// 
  this.earth=null;		// n
  this.sky=null;		// wi
  this.shell=null;		// h[
};

// Pǉ
// star - P
StarsModel.prototype.addStar=function(star){
  this.stars.push(star);
  this.starsMap[star.id]=star;
};

// fǉ
// planet - f
StarsModel.prototype.addPlanet=function(planet){
  this.planets.push(planet);
  if(planet.type===SATERITE){
    this.saterites.push(planet);
  }
};

// nǉ
// earth - n
StarsModel.prototype.addEarth=function(earth){
  this.earth=earth;
  this.addPlanet(earth);
};

// ǉ
// constellation - 
StarsModel.prototype.addConstellation=function(constellation){
  this.constellations.push(constellation);
};

// QƂ鐯̂𗪍瑮iɕύX
StarsModel.prototype.setConstellationName=function(){
  var cMap={},i;
  for(i=0;i<this.constellations.length;i++){
    var cons=this.constellations[i];
    cMap[cons.shortName]=cons.genitive;
  }
  for(i=0;i<this.stars.length;i++){
    var value=cMap[this.stars[i].constellation];
    if(value!==undefined){
      this.stars[i].constellation=value;
    }
  }
};

// f̈ʒuvZ
StarsModel.prototype.calculateCoordinates=function(){
  var count=this.planets.length,i;
  for(i=0;i<count;i++){
    this.planets[i].calculateCoordinates();
  }
  for(i=0;i<count;i++){
    this.planets[i].calculateMEC(this.earth.p,this.earth.tilt);
  }
};

// f̕\ʒuݒ肷
StarsModel.prototype.setPlanetPosition=function(){
  var count=this.planets.length,i;
  for(i=0;i<count;i++){
    this.planets[i].calculateCoordinates();
  }
  for(i=0;i<count;i++){
    this.planets[i].calculateMEC(this.earth.p,this.earth.tilt);
    this.planets[i].setPosition();
  }
  this.setSkyColor();
};

// \IuWFNg쐬
StarsModel.prototype.createObjects=function(){
  var i;
  for(i=0;i<this.stars.length;i++){
    this.stars[i].createObject();
    viewModel.addObject(this.stars[i].obj);
  }
  for(i=0;i<this.planets.length;i++){
    this.planets[i].createObject();
    viewModel.addObject(this.planets[i].obj);
  }
  for(i=0;i<this.constellations.length;i++){
    this.constellations[i].createObject(this.starsMap);
    viewModel.addObject(this.constellations[i].obj);
    this.constellations[i].obj.visible=true;
  }
  var material=new THREE.MeshBasicMaterial({side:THREE.BackSide});
  this.sky=new THREE.Mesh(new THREE.SphereGeometry(7),material);
  viewModel.addObject(this.sky);
  material=new THREE.MeshBasicMaterial
    ({transparent:true,opacity:0.2,color:0x666699,side:THREE.BackSide});
  this.shell=new THREE.Mesh(new THREE.SphereGeometry(1,48,24),material);
  viewModel.addObject(this.shell);
};

// ̐Fݒ肷
StarsModel.prototype.setSkyColor=function(){
  var h=0;
  for(var i=0;i<this.planets.length;i++){
    var pl=this.planets[i];
    if(pl.type===SUN){
      h=pl.obj.position.dot(viewModel.top);
    }
  }
  if(h<-0.2){
    this.sky.material.color.set(0);
  }
  else if(h<0.0){
    var b=parseInt(1275*h+255);
    this.sky.material.color.set(b);
  }
  else if(h<0.2){
    var g=parseInt(1275*h);
    this.sky.material.color.set(0x0000ff|(g<<8));
  }
  else{
    this.sky.material.color.set(0x00ffff);
  }
};

//--------------------------------------------------------------------//
// t@Cǂݍ

// f[^t@Cǂݍ
// fileName - f[^t@C
// func - ǂݍ݊֐
function readDataFile(fileName,func){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      func(xhr.responseText.split(/\r?\n/g));
    }
  };
  xhr.send(null);
}

// f[^ǂݍ
// s - f[^̃Xg
function readStarsData(s){
  var vmag;
  for(var i=0;i<s.length;i++){
    var ss=s[i].trim().replace(/\t/g,' ').split(/\s+/);
    var keyWord=ss[0].toLowerCase();
    if((keyWord=="epoch") && (ss.length>=2)){		// f̊EX
      epoch=parseFloat(ss[1]);
    }
    else if((keyWord=="earth") && (ss.length>=14)){	// n
      starsModel.addEarth(getPlanet(ss));
    }
    else if((keyWord=="planet") && (ss.length>=14)){	// f
      starsModel.addPlanet(getPlanet(ss));
    }
    else if((keyWord=="fixedstar") && (ss.length>=10)){	// P
      var bayer=ss[3],number=parseInt(ss[4]);
      if((bayer=='null') && (number>0)){
      	bayer=number.toString(10);
      }
      vmag=parseFloat(ss[8]);
      var r=vmagToRad(vmag);
      starsModel.addStar
      	(new FixedStar(ss[1],ss[2],ss[5],r,r,
      	      	       readRa1(ss[6]),readDe1(ss[7]),vmag,
      	      	       colorIndexBV(Number(ss[9])),bayer));
    }
    else if((keyWord=="nebula") && (ss.length>=10)){	// _
      var type=ss[4].toLowerCase();
      var r1=parseInt(ss[7]),r2=parseInt(ss[8]);
      vmag=parseFloat(ss[9]);
      if(type===BRINEB){
      	vmag=5.0-0.04*Math.sqrt(r1*r2);
      	r1=Math.max(parseInt(0.02*r1+0.5),1);
      	r2=Math.max(parseInt(0.02*r2+0.5),1);
      }
      else if(type===GALAXY){
      	r1=Math.max(parseInt(0.02*r1+0.5),1);
      	r2=Math.max(parseInt(0.02*r2+0.5),1);
      }
      else{
      	r1=vmagToRad(vmag);
      	r2=r1;
      }
      starsModel.addStar
      	(new FixedStar(ss[1],ss[2],ss[3],r1,r2,readRa2(ss[5]),
      	      	       readDe2(ss[6]),vmag,nebulaColor(type,vmag),
      	      	       null));
    }
    else if(ss.length>=4){				// 
      var count=parseInt(ss[3]);
      var connect=[];
      for(var j=0;j<count;j++){
      	connect[j]=[ss[2*j+4],ss[2*j+5]];
      }
      starsModel.addConstellation
      	(new Constellation(ss[0],ss[1],ss[2],connect));
    }
  }
  starsModel.setConstellationName();
  starsModel.calculateCoordinates();
}

// ff[^Ԃ
// ss - f[^
function getPlanet(ss){
  var type=ss[1].toLowerCase();
  var lofp=TO_RADIAN*Number(ss[8]);
  var lofp2=0;
  var ii=9;
  if(type==SATERITE){
    lofp2=TO_RADIAN*Number(ss[9]);
    ii++;
  }
  var lofan=TO_RADIAN*Number(ss[ii]);
  ii++;
  var lofan2=0;
  if(type==SATERITE){
    lofan2=TO_RADIAN*Number(ss[ii]);
    ii++;
  }
  var inc=TO_RADIAN*Number(ss[ii]);
  var meanl=TO_RADIAN*Number(ss[ii+1]);
  var period=Number(ss[ii+2]);
  var pinv=0;
  if(period!==0){
    if((type==INNER_PLANET) || (type==OUTER_PLANET)){
      pinv=2*Math.PI/(365.25*period);
    }
    else{
      pinv=2*Math.PI/period;
    }
  }
  return new Planet(ss[2],type,parseInt(ss[4]),parseInt(ss[5]),
      	      	    Number(ss[6]),Number(ss[7]),lofp,lofp2,
      	      	    lofan,lofan2,inc,meanl,pinv,
      	      	    TO_RADIAN*Number(ss[ii+3]),ss[3]);
}

// ԌoԂ
// s - Ԍo\
function readRa1(s){
  var idh=s.indexOf('h'),idm=s.indexOf('m'),ids=s.indexOf('s');
  var rah=parseInt(s.substring(0,idh));
  var ram=parseInt(s.substring(idh+1,idm))/60;
  var ras=parseFloat(s.substring(idm+1,ids))/3600;
  return Math.PI/12*(rah+ram+ras);
}

// ԌoԂ
// s - Ԍo\
function readRa2(s){
  var idh=s.indexOf('h'),idm=s.indexOf('m');
  var rah=parseInt(s.substring(0,idh));
  var ram=parseInt(s.substring(idh+1,idm))/60;
  return Math.PI/12*(rah+ram);
}

// Ԉ܂Ԃ
// s - Ԉ܂\
function readDe1(s){
  var idd=s.indexOf('d'),idm=s.indexOf('m'),ids=s.indexOf('s');
  var ded=parseInt(s.substring(1,idd));
  var dem=parseInt(s.substring(idd+1,idm))/60;
  var des=parseFloat(s.substring(idm+1,ids))/3600;
  var de=ded+dem+des;
  if(s.charAt(0)==='-') de=-de;
  return TO_RADIAN*de;
}

// Ԉ܂Ԃ
// s - Ԉ܂\
function readDe2(s){
  var idd=s.indexOf('d'),idm=s.indexOf('m');
  var ded=parseInt(s.substring(1,idd));
  var dem=parseInt(s.substring(idd+1,idm))/60;
  var de=ded+dem;
  if(s.charAt(0)==='-') de=-de;
  return TO_RADIAN*de;
}

// ̕\aԂ
// vm - 
function vmagToRad(vm){
  return Math.max(parseInt(4.5-vm),1);
}

// Cݐf[^ǂݍ
// s - f[^̃Xg
function readMapData(s){
  var list=globe.list;
  list.length=0;
  var row=0,mm=-1,aa=0,bb=0,name='',area=0,block=0;
  while(row<s.length){
    var ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>=2){
      var p=new GlobePoint(Number(ss[0]),Number(ss[1]));
      if(block>0){
      	list[mm][aa][bb]=p;
      	bb++;
      	if(bb==block){
      	  block=0;
      	  if(aa+1==area){
      	    area=0;
      	  }
      	}
      }
    }
    else if(ss.length==1){
      if(isNaN(ss[0])){
      	name=ss[0];
      }
      else if(ss[0]===''){
      }
      else if(area===0){
      	area=parseInt(ss[0]);
      	mm++;
      	list[mm]=[];
      	aa=-1;
      }
      else{
      	block=parseInt(ss[0]);
      	aa++;
      	list[mm][aa]=[];
      	bb=0;
      }
    }
    row++;
  }
}

//--------------------------------------------------------------------//
// \f
// canvasId - \̈ID
var ViewModel=function(canvasId){
  this.canvasFrame=document.getElementById(canvasId);		// `t[
  this.renderer=new THREE.WebGLRenderer({antialias:true});	// _\
  if(!this.renderer){
    alert("three.js ̏Ɏs܂");
  }

  this.renderer.setSize(this.canvasFrame.clientWidth,
      	      	      	this.canvasFrame.clientHeight);
  this.renderer.setClearColor(0x000000,1);
  this.canvasFrame.appendChild(this.renderer.domElement);

  this.labelRenderer=new THREE.CSS2DRenderer();
  this.labelRenderer.setSize(this.canvasFrame.clientWidth,
      	      	      	     this.canvasFrame.clientHeight);
  this.labelRenderer.domElement.style.position='absolute';
  this.labelRenderer.domElement.style.top='0';
  this.labelRenderer.domElement.style.pointerEvents='none';
  this.canvasFrame.appendChild(this.labelRenderer.domElement);

  this.scene=new THREE.Scene();				// V[
  this.initLight();
  this.initCamera();
  this.receives=[];					// NbNΏ
  this.raycaster=new THREE.Raycaster();
  this.axis=null;
  this.sunHeight=0;					// z
  this.dirX=0;						// p
  this.dirY=0;
  this.zoomInv=1;					// k
  this.panX=0;						// `ʒu
  this.panY=0;
  this.rotCoef=Math.PI/this.canvasFrame.clientWidth;	// ]W
  this.zoomCoef=1/this.canvasFrame.clientHeight;	// gkW
  this.panCoef=1.2/this.canvasFrame.clientHeight;	// sړW
  this.pos=new THREE.Vector3();			// \ʒuxNg
  this.camProj=new THREE.Matrix4();		// J̍Wϊ}gbNX
  this.dirPlate=[textPlate('N'),textPlate('NE'),	// pv[g
      	      	 textPlate('E'),textPlate('SE'),
      	      	 textPlate('S'),textPlate('SW'),
      	      	 textPlate('W'),textPlate('NW')];
  for(var i=0;i<this.dirPlate.length;i++){
    this.scene.add(this.dirPlate[i]);
  }
  this.names={};				// ̕\v[g
  this.setLocale();
};

// 
ViewModel.prototype.initLight=function(){
// s
  this.directionalLight=new THREE.DirectionalLight(0xffffff,10);
  this.scene.add(this.directionalLight);
};

// J
ViewModel.prototype.initCamera=function(){
  this.top=new THREE.Vector3(0,0,1);
  this.target=new THREE.Vector3(1,0,0);

  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  this.vRange={l:-0.6*aspect,r:0.6*aspect,t:1.2,b:0};
  this.camera=new THREE.OrthographicCamera
    (this.vRange.l,this.vRange.r,this.vRange.t,this.vRange.b,0,1000);
  this.camera.position.set(0,0,0);
};

// }EXCxg
ViewModel.prototype.initMouseEvent=function(){
  var vm=this,i,mouse2=new THREE.Vector2();
  this.receives.length=0;
  for(i=0;i<starsModel.stars.length;i++){
    this.receives.push(starsModel.stars[i].obj);
  }
  for(i=0;i<starsModel.planets.length;i++){
    this.receives.push(starsModel.planets[i].obj);
  }
  var cfx=2/this.canvasFrame.clientWidth;
  var cfy=2/this.canvasFrame.clientHeight;

  this.canvasFrame.addEventListener('mousedown',viewMousePressed,false);
  this.canvasFrame.addEventListener('contextmenu',viewContextMenu,false);

// }EX{^̏s
  function viewMousePressed(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=e.buttons;
    mouse.set(e.pageX,e.pageY);
    document.addEventListener('mouseup',viewMouseReleased,false);
    document.addEventListener('mousemove',viewMouseMoved,false);
    var bcr=vm.canvasFrame.getBoundingClientRect();
    mouse2.set(cfx*(e.clientX-bcr.left)-1,
      	       -(cfy*(e.clientY-bcr.top)-1));
    vm.raycaster.setFromCamera(mouse2,vm.camera);
    var intersects=vm.raycaster.intersectObjects(vm.receives);
    if(intersects.length>0){
      var name=intersects[0].object.name;
      if(!(name in vm.names)){
      	vm.names[name]=textPlate(name);
      	vm.addObject(vm.names[name]);
      }
      vm.names[name].position.copy(intersects[0].point);
    }
    else{
      for(var key in vm.names){
      	vm.removeObject(vm.names[key]);
      	delete vm.names[key];
      }
    }
  }

// }EX{^𗣂̏s
  function viewMouseReleased(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=0;
    document.removeEventListener('mouseup',viewMouseReleased,false);
    document.removeEventListener('mousemove',viewMouseMoved,false);
  }

// }EX{^ړ̏s
  function viewMouseMoved(e){
    var moved=false;
// {^|]
    if(pressedButtons&0x1){
      vm.dirX+=vm.rotCoef*(e.pageX-mouse.x);
      vm.dirY+=vm.rotCoef*(e.pageY-mouse.y);
      if(vm.dirX<-Math.PI) vm.dirX+=2*Math.PI;
      if(vm.dirX>Math.PI)  vm.dirX-=2*Math.PI;
      vm.dirY=Math.max(Math.min(vm.dirY,0.45*Math.PI),0);
      moved=true;
    }
// {^|gEk
    if(pressedButtons&0x4){
      vm.zoomInv+=vm.zoomCoef*(e.pageY-mouse.y);
      vm.zoomInv=Math.max(Math.min(vm.zoomInv,2),0.5);
      moved=true;
    }
// E{^|sړ
    if(pressedButtons&0x2){
      vm.panX+=vm.panCoef*vm.zoomInv*(e.pageX-mouse.x);
      vm.panY+=vm.panCoef*vm.zoomInv*(mouse.y-e.pageY);
      vm.panX=Math.max(Math.min(vm.panX,1),-1);
      vm.panY=Math.max(Math.min(vm.panY,1.5),-0.4);
      moved=true;
    }
    if(moved){
      vm.setCamera();
      mouse.set(e.pageX,e.pageY);
    }
  }

// j[\}
  function viewContextMenu(e){
    e.preventDefault();
  }
};

// \ʒuݒ肷
ViewModel.prototype.setLocale=function(){
  var th=SIDEREAL0+DAY_RATIO*(julianDay-SIDEREAL_EPOCH);
  th=2.0*Math.PI*(th-Math.floor(th));
  var phy=TO_RADIAN*globe.y,cphy=Math.cos(phy);
  var topx=Math.cos(th)*cphy;
  var topy=Math.sin(th)*cphy;
  var topz=Math.sin(phy);
  this.top.set(topx,topy,topz);
  var tgx=-topx*topz,tgy=-topy*topz,tgz=1-topz*topz,tgp=Math.sqrt(tgz);
  if(tgp===0){
    this.target.set(1,0,0);
  }
  else{
    this.target.set(tgx/tgp,tgy/tgp,tgz/tgp);
  }
  this.camera.up.set(topx,topy,topz);
  var dir=this.target.clone();
  for(var i=0;i<this.dirPlate.length;i++){
    this.dirPlate[i].position.copy(dir);
    dir.applyAxisAngle(this.top,-0.25*Math.PI);
  }
  this.setCamera();
};

// \ʒu
ViewModel.prototype.initView=function(){
  this.dirX=0;
  this.dirY=0;
  this.zoomInv=1;
  this.panX=0;
  this.panY=0;
  this.setLocale();
};

// Jʒuݒ肷
ViewModel.prototype.setCamera=function(){
  var rot=new THREE.Vector3().crossVectors(this.target,this.top);
  var tgt=this.target.clone().applyAxisAngle(rot,this.dirY).
      	    applyAxisAngle(this.top,this.dirX);
  this.camera.lookAt(tgt);
  this.camera.left=this.zoomInv*(this.vRange.l-this.panX);
  this.camera.right=this.zoomInv*(this.vRange.r-this.panX);
  this.camera.top=this.zoomInv*(this.vRange.t-this.panY);
  this.camera.bottom=this.zoomInv*(this.vRange.b-this.panY);
  this.camera.updateProjectionMatrix();
  this.camera.updateMatrix();
  this.camera.updateMatrixWorld();
  this.camera.matrixWorldInverse.getInverse(this.camera.matrixWorld);
  this.directionalLight.position.set(-tgt.x,-tgt.y,-tgt.z);
  this.camProj.multiplyMatrices(this.camera.projectionMatrix,
      	      	      	      	this.camera.matrixWorldInverse);
  for(var i=0;i<this.dirPlate.length;i++){
    this.setPlateView(this.dirPlate[i]);
  }
  for(var key in this.names){
    this.setPlateView(this.names[key]);
  }
};

// v[g̕\ݒ
ViewModel.prototype.setPlateView=function(plate){
  this.pos.copy(plate.position).applyMatrix4(this.camProj);
  if((-1<=this.pos.z) && (this.pos.z<=1)){
    plate.element.style.display='inline';
  }
  else{
    plate.element.style.display='none';
  }
};

// \IuWFNgǉ
ViewModel.prototype.addObject=function(obj){
  this.scene.add(obj);
};

// \IuWFNg폜
ViewModel.prototype.removeObject=function(obj){
  this.scene.remove(obj);
};

// Wݒ肷
ViewModel.prototype.setAxis=function(){
  if(this.axis!==null){
    this.scene.remove(this.axis);
  }
  this.axis=new THREE.AxisHelper(0.2);
  this.axis.position.set(0,0,0);
  this.scene.add(this.axis);
};

// \XV
ViewModel.prototype.update=function(){
  this.renderer.render(this.scene,this.camera);
  this.labelRenderer.render(this.scene,this.camera);
};

// _̎
var GALAXY='galaxy';		// 
var OPENCL='opencl';		// UJc
var GLOBCL='globcl';		// 󐯒c
var PLANEB='planeb';		// f󐯉_
var BRINEB='brineb';		// U_
var GALAXY_COLOR='ffffcc';	// ͂̕\F

// f̎
var SUN='sun';			// z
var INNER_PLANET='inner';	// f
var OUTER_PLANET='outer';	// Of
var SATERITE='saterite';	// q

var TOLERANCE=1.0E-8;		// Pv[̋e덷
var ORBIT_VIEW_COUNT=360;	// O_̐
// fO̕\}eA
var ORBIT_MAT=new THREE.LineBasicMaterial({color:0xffffff});

//--------------------------------------------------------------------//
// 
// name - ̖O
// radius1,radius2 - \a,\ca
// mx,my - ϐԓW (n_) ox,ܓx
// color - \F
var Star=function(name,radius1,radius2,mx,my,color){
  this.id=name;
  this.name=name;
  this.radius1=radius1;
  this.radius2=radius2;
  this.mx=mx;
  this.my=my;
  this.color=color;
};

// \IuWFNg쐬
Star.prototype.createObject=function(){
  var material=new THREE.MeshStandardMaterial
    ({roughness:0.1,metalness:0.8});
  material.color.set(parseInt(this.color,16));
  var geometry=new THREE.SphereGeometry(0.007*this.radius1,8,4);
  this.obj=new THREE.Mesh(geometry,material);
  this.obj.name=this.toString();
  this.setPosition();
};

// \IuWFNg̈ʒuݒ肷
Star.prototype.setPosition=function(){
  var cmy=Math.cos(this.my);
  this.obj.position.set(Math.cos(this.mx)*cmy,Math.sin(this.mx)*cmy,
      	      	      	Math.sin(this.my));
};

//--------------------------------------------------------------------//
// P
// id - ̎ʖ
// constellation - ̑鐯
// name - ̖O
// radius1,radius2 - \a,\ca
// mx,my - ϐԓW (n_) ox,ܓx
// vmag - 
// color - \F
// bayer - ̃oCG
var FixedStar=function(id,constellation,name,radius1,radius2,mx,my,
      	      	       vmag,color,bayer){
  Star.call(this,name,radius1,radius2,mx,my,color);
  this.id=id;
  this.constellation=constellation;
  this.vmag=vmag;
  this.bayer=bayer;
};

// \IuWFNg쐬
FixedStar.prototype.createObject=function(){
  Star.prototype.createObject.call(this);
  if(this.bayer===null){	// _𔼓ɂ
    this.obj.material.transparent=true;
    this.obj.material.opacity=0.8;
  }
};

// P\Ԃ
FixedStar.prototype.toString=function(){
  var s=this.id;
  if((this.bayer!==null) && (this.bayer!=='null')){
    s+=' '+this.bayer;
  }
  if((this.constellation!==null) && (this.constellation!=='null')){
    s+=' '+this.constellation;
  }
  if((this.name!==null) && (this.name!=='null')){
    s+=' '+this.name;
  }
  return s;
};

//--------------------------------------------------------------------//
// ff[^
// name - f̖O
// type - f^Cv
// radius1,radius2 - \a
// sma - Oa AU
// eccen - S
// lofp0,lofp1 - ߓ_o 萔,P
// lofan0,lofan1 - _o 萔,P
// inc - OXΊp(rad)
// meanl - ωo(rad)
// pinv - px(rad/)
// tilt - ԓʂ̌XΊp
// color - \F
var Planet=function(name,type,radius1,radius2,sma,eccen,lofp0,lofp1,
      	      	    lofan0,lofan1,inc,meanl,pinv,tilt,color){
  Star.call(this,name,radius1,radius2,0,0,color);
  this.type=type;
  this.sma=sma;
  this.eccen=eccen;
  this.lofp0=lofp0;
  this.lofp1=lofp1;
  this.lofan0=lofan0;
  this.lofan1=lofan1;
  this.inc=inc;
  this.meanl=meanl;
  this.pinv=pinv;
  this.tilt=tilt;
  this.p=new THREE.Vector3();
};

// fWʒuvZ
Planet.prototype.calculateCoordinates=function(){
  var julianDay2=julianDay-epoch;
  if(this.type===SATERITE) julianDay2=julianDay-DEAULT_EPOCH;
  var lofp=this.lofp0+this.lofp1*julianDay2;
  var lofan=this.lofan0+this.lofan1*julianDay2;
  var m=this.meanl-lofp+this.pinv*julianDay2;
  var eeh=0.5*eccentricAnomaly(m,this.eccen);
  var v=Math.PI;
  if(Math.cos(eeh)!==0.0){
    var tanv=Math.sqrt((1.0+this.eccen)/(1.0-this.eccen));
    v=2.0*Math.atan(tanv*Math.tan(eeh));
  }
  v+=lofp;
  var lens=this.sma*(1.0-this.eccen*Math.cos(2.0*eeh));
  var ss=Math.sin(v-lofan);
  var cinc=1.0-Math.cos(this.inc);
  this.p.set
    (lens*(Math.cos(v)+ss*Math.sin(lofan)*cinc),
     lens*(Math.sin(v)-ss*Math.cos(lofan)*cinc),
     lens*ss*Math.sin(this.inc));
};

// Ovf쐬
Planet.prototype.createOrbit=function(){
  var thpa=this.lofp0-this.lofan0;
  var ccpa=Math.cos(thpa),sspa=Math.sin(thpa);
  var cinc=1.0-Math.cos(this.inc),sinc=Math.sin(this.inc);
  var ccan=Math.cos(this.lofan0)*cinc,ssan=Math.sin(this.lofan0)*cinc;
  var ccp=Math.cos(this.lofp0),ssp=Math.sin(this.lofp0);
  var m11=ccp+sspa*ssan;
  var m12=-ssp+ccpa*ssan;
  var m21=ssp-sspa*ccan;
  var m22=ccp-ccpa*ccan;
  var m31=sspa*sinc;
  var m32=ccpa*sinc;
  var smaY=this.sma*Math.sqrt(1.0-this.eccen*this.eccen);
  var cc=1.0;
  var ss=0.0;
  var dtheta=2.0*Math.PI/ORBIT_VIEW_COUNT;
  var dc=Math.cos(dtheta);
  var ds=Math.sin(dtheta);
  var vCount=3*(ORBIT_VIEW_COUNT+1);
  var vertices=new Float32Array(vCount);
  for(var i=0;i<vCount;i+=3){
    var x0=this.sma*(cc-this.eccen);
    var y0=smaY*ss;
    vertices[i]=m11*x0+m12*y0;
    vertices[i+1]=m21*x0+m22*y0;
    vertices[i+2]=m31*x0+m32*y0;
    var cctemp=cc*dc-ss*ds;
    var sstemp=ss*dc+cc*ds;
    cc=cctemp;
    ss=sstemp;
  }
  var geometry=new THREE.BufferGeometry();
  geometry.addAttribute
    ('position',new THREE.BufferAttribute(vertices,3));
  this.orbit=new THREE.Line(geometry,ORBIT_MAT);
};

// fɐԓWʒuvZ
// p0 - n̉Wʒu
// eps - XΊp
Planet.prototype.calculateMEC=function(p0,eps){
  var epss=Math.sin(eps),epsc=Math.cos(eps);
  var dx=this.p.x,dy=this.p.y,dz=this.p.z;
  if(this.type!==SATERITE){
    dx-=p0.x;
    dy-=p0.y;
    dz-=p0.z;
  }
  var ty=dy*epsc-dz*epss,tz=dy*epss+dz*epsc;
  dy=ty;
  dz=tz;
  var dd=Math.sqrt(dx*dx+dy*dy+dz*dz);
  if(dd===0) return;
  this.my=Math.asin(dz/dd);
  this.mx=Math.atan2(dy,dx);
};

// f\Ԃ
Planet.prototype.toString=function(){
  return this.name;
};

// ̕\FԂ
// bv - Fw B-V
function colorIndexBV(bv){
  if(bv<=0.0){
    var r=Math.max(255+parseInt(382.5*bv),0);
    var g=Math.max(255+parseInt(127.75*bv),0);
    return ((r<<16)|(g<<8)|0xff).toString(16);
  }
  else if(bv<0.8){
    var b=255-parseInt(159.375*bv);
    return (0xffff00|b).toString(16);
  }
  else{
    var g2=Math.max(340-parseInt(106.25*bv),0);
    return (0xff007f|(g2<<8)).toString(16);
  }
}

// _̕\FԂ
// type - _̎
// vmag - 
function nebulaColor(type,vmag){
  if(type===GALAXY){
    return GALAXY_COLOR;
  }
  else if(type===BRINEB){
    var r=Math.min(parseInt(255*-25.5*vmag),255);
    return (r<<16).toString(16);
  }
  else{
    var c=Math.min(parseInt(255*-25.5*vmag),255);
    return ((c<<16)|(c<<8)|c).toString(16);
  }
}

// Newton @gpėSߓ_p߂
// m - ϋߓ_p
// eccen - S
function eccentricAnomaly(m,eccen){
  var ei=m+eccen*Math.sin(m);
  var mi=ei-eccen*Math.sin(ei);
  var dm=Math.abs(m-mi);
  while(dm>TOLERANCE){
    ei+=(m-mi)/(1.0-eccen*Math.cos(ei));
    mi=ei-eccen*Math.sin(ei);
    dm=Math.abs(m-mi);
  }
  return ei;
}

inherits(FixedStar,Star);
inherits(Planet,Star);

// ̕\}eA
var CONS_MAT=new THREE.LineBasicMaterial({color:0xcccccc});

//--------------------------------------------------------------------//
// 
// shortName - ̗
// nomenclature - ̊w
// genitive - ̑i
// connect - ̐A
var Constellation=function(shortName,nomenclature,genitive,connect){
  this.shortName=shortName;
  this.nomenclature=nomenclature;
  this.genitive=genitive;
  this.connect=connect;
  this.visible=false;	// Ԑ̕\
};

// \IuWFNg쐬
// starsMap - P}bv
Constellation.prototype.createObject=function(starsMap){
  var vCount=6*this.connect.length;
  var vertices=new Float32Array(vCount);
  for(var i=0;i<this.connect.length;i++){
    var star1=starsMap[this.connect[i][0]].obj.position;
    var star2=starsMap[this.connect[i][1]].obj.position;
    vertices[6*i]=star1.x;
    vertices[6*i+1]=star1.y;
    vertices[6*i+2]=star1.z;
    vertices[6*i+3]=star2.x;
    vertices[6*i+4]=star2.y;
    vertices[6*i+5]=star2.z;
  }
  var geometry=new THREE.BufferGeometry();
  geometry.addAttribute
    ('position',new THREE.BufferAttribute(vertices,3));
  this.obj=new THREE.LineSegments(geometry,CONS_MAT);
};

// \쐬
function createConstellationTable(){
  var table=document.getElementById('constellation-table');
  var tbody=table.tBodies[0];
  var i;
  for(i=tbody.rows.length-1;i>=0;i--){		// \U
    tbody.removeChild(tbody.rows[i]);
  }
  var con=starsModel.constellations,tr,td;
  for(i=0;i<con.length;i++){
    if(i%4===0) tr=tbody.insertRow(-1);
    td=tr.insertCell(-1);
    var check=document.createElement('input');
    check.type='checkbox';
    check.id='conste'+i;
    check.value=i;
    check.name='constgrp';
    check.onclick=showConstellation;
    check.checked=con[i].obj.visible;
    var label=document.createElement('label');
    label.appendChild(document.createTextNode(con[i].nomenclature));
    label.htmlFor=check.id;
    td.appendChild(check);
    td.appendChild(label);
  }
  var res=starsModel.constellations.length%4;
  if(res>0){
    for(i=res;i<4;i++) tr.insertCell(-1);
  }
}

// ̕\ύX
function showConstellation(){
  var elems=document.getElementsByName('constgrp');
  var con=starsModel.constellations;
  for(var i=0;i<con.length;i++){
    con[i].obj.visible=elems[i].checked;
  }
}

// SĂ̐\
function showAllConstellation(){
  var elems=document.getElementsByName('constgrp');
  var con=starsModel.constellations;
  for(var i=0;i<con.length;i++){
    con[i].obj.visible=true;
    elems[i].checked=true;
  }
}

// SĂ̐\ɂ
function hideAllConstellation(){
  var elems=document.getElementsByName('constgrp');
  var con=starsModel.constellations;
  for(var i=0;i<con.length;i++){
    con[i].obj.visible=false;
    elems[i].checked=false;
  }
}

// \\
function showConstellationTable(){
  hideModals();
  modal[CONSTE_WINDOW].style.zIndex=3;
  createConstellationTable();
}

// \\ɂ
function hideConstellationTable(){
  modal[CONSTE_WINDOW].style.zIndex=1;
}

//--------------------------------------------------------------------//
// nV
// x,y - ϑ_̌oxEܓx
var GlobeMap=function(x,y){
  this.list=[];	// Cݐf[^̃Xg
  this.x=x;
  this.y=y;
  this.canvas=document.getElementById('globe-canvas');	// LoXvf
  this.canvas.width=this.canvas.clientWidth;
  this.canvas.height=this.canvas.clientHeight;
  this.context=this.canvas.getContext('2d');		// ReLXg
  this.context.strokeStyle=FG_COLOR;
  this.context.font=FONT;
  this.cx=parseInt(0.5*this.canvas.width);		// ʒSʒu
  this.cy=parseInt(0.5*this.canvas.height);
  this.radius=parseInt(0.8*Math.min(this.cx,this.cy));	// nVa
  this.target=parseInt(0.1*this.radius);		// Ə\TCY
  this.tr=new THREE.Matrix3();
  this.rotCoef=72/this.radius;
  this.calcMatrix();
  this.initMouseEvent();
};

// }EXCxg
GlobeMap.prototype.initMouseEvent=function(){
  this.canvas.addEventListener('mousedown',globeMousePressed,false);
  this.canvas.addEventListener('contextmenu',globeContextMenu,false);
  var gl=this;

// }EX{^̏s
  function globeMousePressed(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=e.buttons;
    mouse.set(e.pageX,e.pageY);
    document.addEventListener('mouseup',globeMouseReleased,false);
    document.addEventListener('mousemove',globeMouseMoved,false);
  }

// }EX{^𗣂̏s
  function globeMouseReleased(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=0;
    document.removeEventListener('mouseup',globeMouseReleased,false);
    document.removeEventListener('mousemove',globeMouseMoved,false);
  }

// }EX{^ړ̏s
  function globeMouseMoved(e){
// {^|]
    if(pressedButtons&0x1){
      var dx=gl.rotCoef*(mouse.x-e.pageX);
      gl.x+=dx;
      gl.y+=gl.rotCoef*(e.pageY-mouse.y);
      if(gl.x<-180) gl.x+=360;
      if(gl.x>180)  gl.x-=360;
      gl.y=Math.max(Math.min(gl.y,90),-90);
      moveTime(2.4e5*dx);
      gl.calcMatrix();
      gl.draw();
      mouse.set(e.pageX,e.pageY);
    }
  }

// j[\}
  function globeContextMenu(e){
    e.preventDefault();
  }
};

// Wϊ}gbNXvZ
GlobeMap.prototype.calcMatrix=function(){
  var th=TO_RADIAN*this.x,phy=TO_RADIAN*this.y;
  var cth=Math.cos(th),sth=Math.sin(th);
  var cphy=Math.cos(phy),sphy=Math.sin(phy);
  this.tr.set(-sth,cth,0,cth*sphy,sth*sphy,cphy,cth*cphy,
      	      sth*cphy,-sphy);
};

// `悷
GlobeMap.prototype.draw=function(){
  this.context.fillStyle=BG_COLOR;
  this.context.fillRect(0,0,this.canvas.width,this.canvas.height);
  this.context.beginPath();
  this.context.arc(this.cx,this.cy,this.radius,0,2*Math.PI,false);
  for(var i=0;i<this.list.length;i++){
    for(var j=0;j<this.list[i].length;j++){
      var p=this.list[i][j];
      var prevp=p[0].getGlobe(this.cx,this.cy,this.radius,this.tr);
      this.context.moveTo(prevp.x,prevp.y);
      for(var k=1;k<p.length;k++){
      	var vp=p[k].getGlobe(this.cx,this.cy,this.radius,this.tr);
      	if((prevp.z>=0) && (vp.z>=0)){
      	  this.context.lineTo(vp.x,vp.y);
      	}
      	else{
      	  this.context.moveTo(vp.x,vp.y);
      	}
      	prevp=vp;
      }
    }
  }
// Ə
  this.context.moveTo(this.cx-this.target,this.cy);
  this.context.lineTo(this.cx+this.target,this.cy);
  this.context.moveTo(this.cx,this.cy-this.target);
  this.context.lineTo(this.cx,this.cy+this.target);
  this.context.closePath();
  this.context.stroke();
  this.drawLocale();
};

// ܓxEox`悷
GlobeMap.prototype.drawLocale=function(){
  var xx='oxF',yy='ܓxF';
  if(this.x>=0){
    xx+='E ';
  }
  else{
    xx+='W ';
  }
  xx+=Math.abs(this.x).toFixed(1);
  if(this.y>=0){
    yy+='N ';
  }
  else{
    yy+='S ';
  }
  yy+=Math.abs(this.y).toFixed(1);
  this.context.fillStyle=FG_COLOR;
  this.context.fillText(yy,5,FONT_SIZE);
  this.context.fillText(xx,5,2*FONT_SIZE);
};

//--------------------------------------------------------------------//
// ̓_
// x - ox
// y - ܓx
var GlobePoint=function(x,y){
  this.x=x;
  this.y=y;
  var rx=TO_RADIAN*x;
  var ry=TO_RADIAN*y;
  this.p=new THREE.Vector3(Math.cos(rx)*Math.cos(ry),
      	      	      	   Math.sin(rx)*Math.cos(ry),
      	      	      	   -Math.sin(ry));
  this.vp=new THREE.Vector3();
};

// nV̉ʏ3_Ԃ
// cx,cy - plS_
// radius - nV̕`攼a
// tr - Wϊs
GlobePoint.prototype.getGlobe=function(cx,cy,radius,tr){
  this.vp.copy(this.p).applyMatrix3(tr);
  this.vp.set(parseInt(radius*this.vp.x+cx),
      	      parseInt(radius*this.vp.y+cy),
      	      parseInt(radius*this.vp.z));
  return this.vp;
};

// nV\
function showGlobe(){
  hideModals();
  modal[GLOBE_WINDOW].style.zIndex=3;
  globe.draw();
}

// nV\ɂ
function hideGlobe(){
  modal[GLOBE_WINDOW].style.zIndex=1;
}

// Ƃ̓i[Nj
var DAY_OF_MONTH=[31,28,31,30,31,30,31,31,30,31,30,31];

// ̓Ԃ
// year,mon - N,(-1)
function dayOfMonth(year,mon){
  if(mon==1){		// [NQ
    if(((year%4===0) && (year%100!==0)) || (year%400===0)) return 29;
  }
  return DAY_OF_MONTH[mon];
}

// J_[\쐬
function createCalendarTable(){
  var year=currentDate.getUTCFullYear();
  var mon=currentDate.getUTCMonth();
  var day=currentDate.getUTCDate();
  currentDate.setUTCDate(1);
  var w=currentDate.getUTCDay();		// n߂̗j
  currentDate.setUTCDate(day);
  var dayCount=dayOfMonth(year,mon);
  var table=document.getElementById('calendar-table');
  table.caption.innerHTML=year+'/'+(mon+1);	// N^
  var tbody=table.tBodies[0];
  var i;
  for(i=tbody.rows.length-1;i>0;i--){		// ɂU
    tbody.removeChild(tbody.rows[i]);
  }
  var tr=tbody.insertRow(-1),td;
  for(i=0;i<w;i++){
    tr.insertCell(-1);
  }
  for(i=0;i<dayCount;i++){
    if((i!==0) && ((i+w)%7===0)){		// ̏T
      tr=tbody.insertRow(-1);
    }
    td=tr.insertCell(-1);
    var dateRButton=document.createElement('input');
    dateRButton.type='radio';
    dateRButton.id='d'+(i+1);
    dateRButton.value=i+1;
    dateRButton.name='date';
    dateRButton.onclick=changeDay;
    dateRButton.checked=(i+1==day);
    var label=document.createElement('label');
    label.appendChild(document.createTextNode(i+1));
    label.htmlFor=dateRButton.id;
    td.appendChild(dateRButton);
    td.appendChild(label);
  }
  w=(w+dayCount)%7;
  if(w>0){
    for(i=w;i<7;i++){
      tr.insertCell(-1);
    }
  }
}

// ݂̓ύX
function changeDay(){
  var elems=document.getElementsByName('date');
  for(var i=0;i<elems.length;i++){
    if(elems[i].checked){
      currentDate.setUTCDate(elems[i].value);
      setTime();
    }
  }
}

// Ǒֈړ
function beforeMonth(){
  var year=currentDate.getUTCFullYear()-1;
  var mon=(currentDate.getUTCMonth()+11)%12;
  var day=Math.min(dayOfMonth(year,mon),currentDate.getUTCDate());
  currentDate.setUTCDate(day);
  currentDate.setUTCMonth(mon);
  if(mon===11){
    currentDate.setUTCFullYear(year);
  }
  setTime();
  createCalendarTable();
}

// ̌ֈړ
function afterMonth(){
  var year=currentDate.getUTCFullYear()+1;
  var mon=(currentDate.getUTCMonth()+1)%12;
  var day=Math.min(dayOfMonth(year,mon),currentDate.getUTCDate());
  currentDate.setUTCDate(day);
  currentDate.setUTCMonth(mon);
  if(mon===0){
    currentDate.setUTCFullYear(year);
  }
  setTime();
  createCalendarTable();
}

// J_[\
function showCalendar(){
  hideModals();
  modal[CALENDAR_WINDOW].style.zIndex=3;
  createCalendarTable();
}

// J_[\ɂ
function hideCalendar(){
  modal[CALENDAR_WINDOW].style.zIndex=1;
}

//--------------------------------------------------------------------//
// v
var Clock=function(){
  this.canvas=document.getElementById('clock-canvas');	// LoXvf
  this.canvas.width=this.canvas.clientWidth;
  this.canvas.height=this.canvas.clientHeight;
  this.context=this.canvas.getContext('2d');		// ReLXg
  this.cx=parseInt(0.5*this.canvas.width);		// ʒSʒu
  this.cy=parseInt(0.5*this.canvas.height);
  this.radius=0.8*Math.min(this.cx,this.cy);		// vga
  this.radius2=0.95*this.radius;			// vڐa
  this.hLen=0.6*this.radius;				// Zj
  this.mLen=0.8*this.radius;				// j
  this.sLen=0.9*this.radius;				// bj
  this.w=3;						// jEZj
  this.coefT=8.64E6/this.canvas.width;
  this.initMouseEvent();
};

// }EXCxg
Clock.prototype.initMouseEvent=function(){
  this.canvas.addEventListener('mousedown',clockMousePressed,false);
  this.canvas.addEventListener('contextmenu',clockContextMenu,false);
  var cl=this;

// }EX{^̏s
  function clockMousePressed(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=e.buttons;
    mouse.set(e.pageX,e.pageY);
    document.addEventListener('mouseup',clockMouseReleased,false);
    document.addEventListener('mousemove',clockMouseMoved,false);
  }

// }EX{^𗣂̏s
  function clockMouseReleased(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=0;
    document.removeEventListener('mouseup',clockMouseReleased,false);
    document.removeEventListener('mousemove',clockMouseMoved,false);
  }

// }EX{^ړ̏s
  function clockMouseMoved(e){
// {^|]
    if(pressedButtons&0x1){
      var dt=cl.coefT*(e.clientX-mouse.x);
      moveTime(dt);
      cl.draw();
      mouse.set(e.pageX,e.pageY);
    }
  }

// j[\}
  function clockContextMenu(e){
    e.preventDefault();
  }
};

// v`悷
Clock.prototype.draw=function(){
  var hour=currentDate.getUTCHours();
  var min=currentDate.getUTCMinutes();
  var sec=currentDate.getUTCSeconds();

  this.context.fillStyle=BG_COLOR;
  this.context.fillRect(0,0,this.canvas.width,this.canvas.height);
  this.context.fillStyle=FG_COLOR;
  this.context.strokeStyle=FG_COLOR;
  this.context.beginPath();
  this.context.arc(this.cx,this.cy,this.radius,0,2*Math.PI,false);
  var dth=Math.PI/6,th,cc,ss;
// ڐ
  for(var i=0;i<12;i++){
    th=dth*i;
    cc=Math.cos(th);
    ss=Math.sin(th);
    this.context.moveTo(this.cx+parseInt(this.radius*ss),
      	      	      	this.cy-parseInt(this.radius*cc));
    this.context.lineTo(this.cx+parseInt(this.radius2*ss),
      	      	      	this.cy-parseInt(this.radius2*cc));
  }
// bj
  this.context.moveTo(this.cx,this.cy);
  th=Math.PI*sec/30;
  cc=Math.cos(th);
  ss=Math.sin(th);
  this.context.lineTo(this.cx+parseInt(this.sLen*ss),
      	      	      this.cy-parseInt(this.sLen*cc));
  this.context.closePath();
  this.context.stroke();
// j
  th=(2*Math.PI*min+th)/60;
  this.drawBroadHand(th,this.mLen,this.w);
// Zj
  th=(2*Math.PI*hour+th)/12;
  this.drawBroadHand(th,this.hLen,this.w);
};

// Lj`悷
// theta - j̊px
// len - j̒
// width - j̕
Clock.prototype.drawBroadHand=function(theta,len,width){
  var cc=Math.cos(theta),ss=Math.sin(theta);
  this.context.beginPath();
  this.context.moveTo(this.cx+parseInt(len*ss),
      	      	      this.cy-parseInt(len*cc));
  this.context.lineTo(this.cx+parseInt(width*cc),
      	      	      this.cy+parseInt(width*ss));
  this.context.lineTo(this.cx-parseInt(width*ss),
      	      	      this.cy+parseInt(width*cc));
  this.context.lineTo(this.cx-parseInt(width*cc),
      	      	      this.cy-parseInt(width*ss));
  this.context.closePath();
  this.context.fill();
};

// v\
function showClock(){
  hideModals();
  modal[CLOCK_WINDOW].style.zIndex=3;
  clock.draw();
}

// v\ɂ
function hideClock(){
  modal[CLOCK_WINDOW].style.zIndex=1;
}
