//--------------------------------------------------------------------//
// v
var Clock=function(){
  this.canvas=document.getElementById('clock-canvas');	// LoXvf
  this.canvas.width=this.canvas.clientWidth;
  this.canvas.height=this.canvas.clientHeight;
  this.context=this.canvas.getContext('2d');		// ReLXg
  this.cx=parseInt(0.5*this.canvas.width);		// ʒSʒu
  this.cy=parseInt(0.5*this.canvas.height);
  this.radius=0.8*Math.min(this.cx,this.cy);		// vga
  this.radius2=0.95*this.radius;			// vڐa
  this.hLen=0.6*this.radius;				// Zj
  this.mLen=0.8*this.radius;				// j
  this.sLen=0.9*this.radius;				// bj
  this.w=3;						// jEZj
  this.coefT=8.64E6/this.canvas.width;
  this.initMouseEvent();
};

// }EXCxg
Clock.prototype.initMouseEvent=function(){
  this.canvas.addEventListener('mousedown',clockMousePressed,false);
  this.canvas.addEventListener('contextmenu',clockContextMenu,false);
  var cl=this;

// }EX{^̏s
  function clockMousePressed(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=e.buttons;
    mouse.set(e.pageX,e.pageY);
    document.addEventListener('mouseup',clockMouseReleased,false);
    document.addEventListener('mousemove',clockMouseMoved,false);
  }

// }EX{^𗣂̏s
  function clockMouseReleased(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=0;
    document.removeEventListener('mouseup',clockMouseReleased,false);
    document.removeEventListener('mousemove',clockMouseMoved,false);
  }

// }EX{^ړ̏s
  function clockMouseMoved(e){
// {^|]
    if(pressedButtons&0x1){
      var dt=cl.coefT*(e.clientX-mouse.x);
      moveTime(dt);
      cl.draw();
      mouse.set(e.pageX,e.pageY);
    }
  }

// j[\}
  function clockContextMenu(e){
    e.preventDefault();
  }
};

// v`悷
Clock.prototype.draw=function(){
  var hour=currentDate.getUTCHours();
  var min=currentDate.getUTCMinutes();
  var sec=currentDate.getUTCSeconds();

  this.context.fillStyle=BG_COLOR;
  this.context.fillRect(0,0,this.canvas.width,this.canvas.height);
  this.context.fillStyle=FG_COLOR;
  this.context.strokeStyle=FG_COLOR;
  this.context.beginPath();
  this.context.arc(this.cx,this.cy,this.radius,0,2*Math.PI,false);
  var dth=Math.PI/6,th,cc,ss;
// ڐ
  for(var i=0;i<12;i++){
    th=dth*i;
    cc=Math.cos(th);
    ss=Math.sin(th);
    this.context.moveTo(this.cx+parseInt(this.radius*ss),
      	      	      	this.cy-parseInt(this.radius*cc));
    this.context.lineTo(this.cx+parseInt(this.radius2*ss),
      	      	      	this.cy-parseInt(this.radius2*cc));
  }
// bj
  this.context.moveTo(this.cx,this.cy);
  th=Math.PI*sec/30;
  cc=Math.cos(th);
  ss=Math.sin(th);
  this.context.lineTo(this.cx+parseInt(this.sLen*ss),
      	      	      this.cy-parseInt(this.sLen*cc));
  this.context.closePath();
  this.context.stroke();
// j
  th=(2*Math.PI*min+th)/60;
  this.drawBroadHand(th,this.mLen,this.w);
// Zj
  th=(2*Math.PI*hour+th)/12;
  this.drawBroadHand(th,this.hLen,this.w);
};

// Lj`悷
// theta - j̊px
// len - j̒
// width - j̕
Clock.prototype.drawBroadHand=function(theta,len,width){
  var cc=Math.cos(theta),ss=Math.sin(theta);
  this.context.beginPath();
  this.context.moveTo(this.cx+parseInt(len*ss),
      	      	      this.cy-parseInt(len*cc));
  this.context.lineTo(this.cx+parseInt(width*cc),
      	      	      this.cy+parseInt(width*ss));
  this.context.lineTo(this.cx-parseInt(width*ss),
      	      	      this.cy+parseInt(width*cc));
  this.context.lineTo(this.cx-parseInt(width*cc),
      	      	      this.cy-parseInt(width*ss));
  this.context.closePath();
  this.context.fill();
};

// v\
function showClock(){
  hideModals();
  modal[CLOCK_WINDOW].style.zIndex=3;
  clock.draw();
}

// v\ɂ
function hideClock(){
  modal[CLOCK_WINDOW].style.zIndex=1;
}
