// ̕\}eA
var CONS_MAT=new THREE.LineBasicMaterial({color:0xcccccc});

//--------------------------------------------------------------------//
// 
// shortName - ̗
// nomenclature - ̊w
// genitive - ̑i
// connect - ̐A
var Constellation=function(shortName,nomenclature,genitive,connect){
  this.shortName=shortName;
  this.nomenclature=nomenclature;
  this.genitive=genitive;
  this.connect=connect;
  this.visible=false;	// Ԑ̕\
};

// \IuWFNg쐬
// starsMap - P}bv
Constellation.prototype.createObject=function(starsMap){
  var vCount=6*this.connect.length;
  var vertices=new Float32Array(vCount);
  for(var i=0;i<this.connect.length;i++){
    var star1=starsMap[this.connect[i][0]].obj.position;
    var star2=starsMap[this.connect[i][1]].obj.position;
    vertices[6*i]=star1.x;
    vertices[6*i+1]=star1.y;
    vertices[6*i+2]=star1.z;
    vertices[6*i+3]=star2.x;
    vertices[6*i+4]=star2.y;
    vertices[6*i+5]=star2.z;
  }
  var geometry=new THREE.BufferGeometry();
  geometry.addAttribute
    ('position',new THREE.BufferAttribute(vertices,3));
  this.obj=new THREE.LineSegments(geometry,CONS_MAT);
};

// \쐬
function createConstellationTable(){
  var table=document.getElementById('constellation-table');
  var tbody=table.tBodies[0];
  var i;
  for(i=tbody.rows.length-1;i>=0;i--){		// \U
    tbody.removeChild(tbody.rows[i]);
  }
  var con=starsModel.constellations,tr,td;
  for(i=0;i<con.length;i++){
    if(i%4===0) tr=tbody.insertRow(-1);
    td=tr.insertCell(-1);
    var check=document.createElement('input');
    check.type='checkbox';
    check.id='conste'+i;
    check.value=i;
    check.name='constgrp';
    check.onclick=showConstellation;
    check.checked=con[i].obj.visible;
    var label=document.createElement('label');
    label.appendChild(document.createTextNode(con[i].nomenclature));
    label.htmlFor=check.id;
    td.appendChild(check);
    td.appendChild(label);
  }
  var res=starsModel.constellations.length%4;
  if(res>0){
    for(i=res;i<4;i++) tr.insertCell(-1);
  }
}

// ̕\ύX
function showConstellation(){
  var elems=document.getElementsByName('constgrp');
  var con=starsModel.constellations;
  for(var i=0;i<con.length;i++){
    con[i].obj.visible=elems[i].checked;
  }
}

// SĂ̐\
function showAllConstellation(){
  var elems=document.getElementsByName('constgrp');
  var con=starsModel.constellations;
  for(var i=0;i<con.length;i++){
    con[i].obj.visible=true;
    elems[i].checked=true;
  }
}

// SĂ̐\ɂ
function hideAllConstellation(){
  var elems=document.getElementsByName('constgrp');
  var con=starsModel.constellations;
  for(var i=0;i<con.length;i++){
    con[i].obj.visible=false;
    elems[i].checked=false;
  }
}

// \\
function showConstellationTable(){
  hideModals();
  modal[CONSTE_WINDOW].style.zIndex=3;
  createConstellationTable();
}

// \\ɂ
function hideConstellationTable(){
  modal[CONSTE_WINDOW].style.zIndex=1;
}
