//--------------------------------------------------------------------//
// nV
// x,y - ϑ_̌oxEܓx
var GlobeMap=function(x,y){
  this.list=[];	// Cݐf[^̃Xg
  this.x=x;
  this.y=y;
  this.canvas=document.getElementById('globe-canvas');	// LoXvf
  this.canvas.width=this.canvas.clientWidth;
  this.canvas.height=this.canvas.clientHeight;
  this.context=this.canvas.getContext('2d');		// ReLXg
  this.context.strokeStyle=FG_COLOR;
  this.context.font=FONT;
  this.cx=parseInt(0.5*this.canvas.width);		// ʒSʒu
  this.cy=parseInt(0.5*this.canvas.height);
  this.radius=parseInt(0.8*Math.min(this.cx,this.cy));	// nVa
  this.target=parseInt(0.1*this.radius);		// Ə\TCY
  this.tr=new THREE.Matrix3();
  this.rotCoef=72/this.radius;
  this.calcMatrix();
  this.initMouseEvent();
};

// }EXCxg
GlobeMap.prototype.initMouseEvent=function(){
  this.canvas.addEventListener('mousedown',globeMousePressed,false);
  this.canvas.addEventListener('contextmenu',globeContextMenu,false);
  var gl=this;

// }EX{^̏s
  function globeMousePressed(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=e.buttons;
    mouse.set(e.pageX,e.pageY);
    document.addEventListener('mouseup',globeMouseReleased,false);
    document.addEventListener('mousemove',globeMouseMoved,false);
  }

// }EX{^𗣂̏s
  function globeMouseReleased(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=0;
    document.removeEventListener('mouseup',globeMouseReleased,false);
    document.removeEventListener('mousemove',globeMouseMoved,false);
  }

// }EX{^ړ̏s
  function globeMouseMoved(e){
// {^|]
    if(pressedButtons&0x1){
      var dx=gl.rotCoef*(mouse.x-e.pageX);
      gl.x+=dx;
      gl.y+=gl.rotCoef*(e.pageY-mouse.y);
      if(gl.x<-180) gl.x+=360;
      if(gl.x>180)  gl.x-=360;
      gl.y=Math.max(Math.min(gl.y,90),-90);
      moveTime(2.4e5*dx);
      gl.calcMatrix();
      gl.draw();
      mouse.set(e.pageX,e.pageY);
    }
  }

// j[\}
  function globeContextMenu(e){
    e.preventDefault();
  }
};

// Wϊ}gbNXvZ
GlobeMap.prototype.calcMatrix=function(){
  var th=TO_RADIAN*this.x,phy=TO_RADIAN*this.y;
  var cth=Math.cos(th),sth=Math.sin(th);
  var cphy=Math.cos(phy),sphy=Math.sin(phy);
  this.tr.set(-sth,cth,0,cth*sphy,sth*sphy,cphy,cth*cphy,
      	      sth*cphy,-sphy);
};

// `悷
GlobeMap.prototype.draw=function(){
  this.context.fillStyle=BG_COLOR;
  this.context.fillRect(0,0,this.canvas.width,this.canvas.height);
  this.context.beginPath();
  this.context.arc(this.cx,this.cy,this.radius,0,2*Math.PI,false);
  for(var i=0;i<this.list.length;i++){
    for(var j=0;j<this.list[i].length;j++){
      var p=this.list[i][j];
      var prevp=p[0].getGlobe(this.cx,this.cy,this.radius,this.tr);
      this.context.moveTo(prevp.x,prevp.y);
      for(var k=1;k<p.length;k++){
      	var vp=p[k].getGlobe(this.cx,this.cy,this.radius,this.tr);
      	if((prevp.z>=0) && (vp.z>=0)){
      	  this.context.lineTo(vp.x,vp.y);
      	}
      	else{
      	  this.context.moveTo(vp.x,vp.y);
      	}
      	prevp=vp;
      }
    }
  }
// Ə
  this.context.moveTo(this.cx-this.target,this.cy);
  this.context.lineTo(this.cx+this.target,this.cy);
  this.context.moveTo(this.cx,this.cy-this.target);
  this.context.lineTo(this.cx,this.cy+this.target);
  this.context.closePath();
  this.context.stroke();
  this.drawLocale();
};

// ܓxEox`悷
GlobeMap.prototype.drawLocale=function(){
  var xx='oxF',yy='ܓxF';
  if(this.x>=0){
    xx+='E ';
  }
  else{
    xx+='W ';
  }
  xx+=Math.abs(this.x).toFixed(1);
  if(this.y>=0){
    yy+='N ';
  }
  else{
    yy+='S ';
  }
  yy+=Math.abs(this.y).toFixed(1);
  this.context.fillStyle=FG_COLOR;
  this.context.fillText(yy,5,FONT_SIZE);
  this.context.fillText(xx,5,2*FONT_SIZE);
};

//--------------------------------------------------------------------//
// ̓_
// x - ox
// y - ܓx
var GlobePoint=function(x,y){
  this.x=x;
  this.y=y;
  var rx=TO_RADIAN*x;
  var ry=TO_RADIAN*y;
  this.p=new THREE.Vector3(Math.cos(rx)*Math.cos(ry),
      	      	      	   Math.sin(rx)*Math.cos(ry),
      	      	      	   -Math.sin(ry));
  this.vp=new THREE.Vector3();
};

// nV̉ʏ3_Ԃ
// cx,cy - plS_
// radius - nV̕`攼a
// tr - Wϊs
GlobePoint.prototype.getGlobe=function(cx,cy,radius,tr){
  this.vp.copy(this.p).applyMatrix3(tr);
  this.vp.set(parseInt(radius*this.vp.x+cx),
      	      parseInt(radius*this.vp.y+cy),
      	      parseInt(radius*this.vp.z));
  return this.vp;
};

// nV\
function showGlobe(){
  hideModals();
  modal[GLOBE_WINDOW].style.zIndex=3;
  globe.draw();
}

// nV\ɂ
function hideGlobe(){
  modal[GLOBE_WINDOW].style.zIndex=1;
}
