//--------------------------------------------------------------------//
// vl^E

var starsModel;			// f[^f
var viewModel;			// \f
var globe;			// Cݐf[^
var epoch;			// EX
var currentDate;		// ݓ
var julianDay;			// EX
var pressedButtons;		// ꂽ}EX{^
var mouse;			// }EXʒu
var clock;			// v
var modal;			// [_EBhE

var EPOCH_JD=2440587.5;		// 1970 N 1  1  00:00:00 GMT ̃EX
var MJD_EPOCH=2400000.5;	// EX̊_
var SIDEREAL0=0.67239;		// P
var DAY_RATIO=1.00273781;	// z^P
var SIDEREAL_EPOCH=2440000.5;	// P̊_
var MILLIS_TO_DAY=1.0/8.64E7;	// Ԃ~b֕ϊW
var DEAULT_EPOCH=2451545;	// ftHg̊EX
var TO_RADIAN=Math.PI/180.0;	// pxWAɕϊW

var FONT_SIZE=15;			// tHgTCY
var FONT=FONT_SIZE+"px 'Arial'";	// tHg
var FG_COLOR='#ffffff';			// OiF
var BG_COLOR='#000000';			// wiF

var CONSTE_WINDOW=0;			// EBhE
var GLOBE_WINDOW=1;			// ϑn_EBhE
var CALENDAR_WINDOW=2;			// J_[EBhE
var CLOCK_WINDOW=3;			// EBhE

// vl^E
// starsFileName - f[^t@C
// mapFileName - Cݐf[^t@C
// lx,ly - ox,ܓx
function initPlanetarium(starsFileName,mapFileName,lx,ly){
  starsModel=new StarsModel();
  globe=new GlobeMap(lx,ly);
  epoch=DEAULT_EPOCH;
  mouse=new THREE.Vector2();
  clock=new Clock();
  currentDate=new Date();
  currentDate.setTime(currentDate.getTime()+2.4e5*lx);
  julianDay=EPOCH_JD+MILLIS_TO_DAY*currentDate.getTime();
  document.getElementById('digitalclock').textContent=dateString();
  readDataFile(starsFileName,readStarsData);
  readDataFile(mapFileName,readMapData);
  viewModel=new ViewModel('planetarium-canvas');
  starsModel.createObjects();
  starsModel.setSkyColor();
  viewModel.initMouseEvent();
  modal=[document.getElementById('constellation'),
      	 document.getElementById('globe'),
      	 document.getElementById('calendar'),
      	 document.getElementById('clock')];
  loop();
}

// [v֐
var step=0;
function loop(){
  step++;
  viewModel.update();
  requestAnimationFrame(loop);
}

// v[gԂ
// text - \镶
function textPlate(text){
  var elem=document.createElement('div');
  elem.style.font=FONT;
  elem.style.color=FG_COLOR;
  elem.style.backgroundColor=BG_COLOR;
  elem.style.top='-0.5em';
  elem.style.left=(0.25*text.length)+'em';
  elem.textContent=text;
  return new THREE.CSS2DObject(elem);
}

// Ԃ𓮂
// dt - Ԉړ
function moveTime(dt){
  currentDate.setTime(currentDate.getTime()+dt);
  setTime();
}

// Ԃݒ肷
function setTime(){
  julianDay=EPOCH_JD+MILLIS_TO_DAY*currentDate.getTime();
  viewModel.setLocale();
  starsModel.setPlanetPosition();
  document.getElementById('digitalclock').textContent=dateString();
}

// Ԃ
function dateString(){
  return currentDate.getUTCFullYear()+'/'
      	+('0'+(currentDate.getUTCMonth()+1)).slice(-2)+'/'
      	+('0'+currentDate.getUTCDate()).slice(-2)+' '
      	+('0'+currentDate.getUTCHours()).slice(-2)+':'
      	+('0'+currentDate.getUTCMinutes()).slice(-2)+':'
      	+('0'+currentDate.getUTCSeconds()).slice(-2);
}

// [_EBhE
function hideModals(){
  for(var i=0;i<modal.length;i++) modal[i].style.zIndex=1;
}

// pNX쐬
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}
