// _̎
var GALAXY='galaxy';		// 
var OPENCL='opencl';		// UJc
var GLOBCL='globcl';		// 󐯒c
var PLANEB='planeb';		// f󐯉_
var BRINEB='brineb';		// U_
var GALAXY_COLOR='ffffcc';	// ͂̕\F

// f̎
var SUN='sun';			// z
var INNER_PLANET='inner';	// f
var OUTER_PLANET='outer';	// Of
var SATERITE='saterite';	// q

var TOLERANCE=1.0E-8;		// Pv[̋e덷
var ORBIT_VIEW_COUNT=360;	// O_̐
// fO̕\}eA
var ORBIT_MAT=new THREE.LineBasicMaterial({color:0xffffff});

//--------------------------------------------------------------------//
// 
// name - ̖O
// radius1,radius2 - \a,\ca
// mx,my - ϐԓW (n_) ox,ܓx
// color - \F
var Star=function(name,radius1,radius2,mx,my,color){
  this.id=name;
  this.name=name;
  this.radius1=radius1;
  this.radius2=radius2;
  this.mx=mx;
  this.my=my;
  this.color=color;
};

// \IuWFNg쐬
Star.prototype.createObject=function(){
  var material=new THREE.MeshStandardMaterial
    ({roughness:0.1,metalness:0.8});
  material.color.set(parseInt(this.color,16));
  var geometry=new THREE.SphereGeometry(0.007*this.radius1,8,4);
  this.obj=new THREE.Mesh(geometry,material);
  this.obj.name=this.toString();
  this.setPosition();
};

// \IuWFNg̈ʒuݒ肷
Star.prototype.setPosition=function(){
  var cmy=Math.cos(this.my);
  this.obj.position.set(Math.cos(this.mx)*cmy,Math.sin(this.mx)*cmy,
      	      	      	Math.sin(this.my));
};

//--------------------------------------------------------------------//
// P
// id - ̎ʖ
// constellation - ̑鐯
// name - ̖O
// radius1,radius2 - \a,\ca
// mx,my - ϐԓW (n_) ox,ܓx
// vmag - 
// color - \F
// bayer - ̃oCG
var FixedStar=function(id,constellation,name,radius1,radius2,mx,my,
      	      	       vmag,color,bayer){
  Star.call(this,name,radius1,radius2,mx,my,color);
  this.id=id;
  this.constellation=constellation;
  this.vmag=vmag;
  this.bayer=bayer;
};

// \IuWFNg쐬
FixedStar.prototype.createObject=function(){
  Star.prototype.createObject.call(this);
  if(this.bayer===null){	// _𔼓ɂ
    this.obj.material.transparent=true;
    this.obj.material.opacity=0.8;
  }
};

// P\Ԃ
FixedStar.prototype.toString=function(){
  var s=this.id;
  if((this.bayer!==null) && (this.bayer!=='null')){
    s+=' '+this.bayer;
  }
  if((this.constellation!==null) && (this.constellation!=='null')){
    s+=' '+this.constellation;
  }
  if((this.name!==null) && (this.name!=='null')){
    s+=' '+this.name;
  }
  return s;
};

//--------------------------------------------------------------------//
// ff[^
// name - f̖O
// type - f^Cv
// radius1,radius2 - \a
// sma - Oa AU
// eccen - S
// lofp0,lofp1 - ߓ_o 萔,P
// lofan0,lofan1 - _o 萔,P
// inc - OXΊp(rad)
// meanl - ωo(rad)
// pinv - px(rad/)
// tilt - ԓʂ̌XΊp
// color - \F
var Planet=function(name,type,radius1,radius2,sma,eccen,lofp0,lofp1,
      	      	    lofan0,lofan1,inc,meanl,pinv,tilt,color){
  Star.call(this,name,radius1,radius2,0,0,color);
  this.type=type;
  this.sma=sma;
  this.eccen=eccen;
  this.lofp0=lofp0;
  this.lofp1=lofp1;
  this.lofan0=lofan0;
  this.lofan1=lofan1;
  this.inc=inc;
  this.meanl=meanl;
  this.pinv=pinv;
  this.tilt=tilt;
  this.p=new THREE.Vector3();
};

// fWʒuvZ
Planet.prototype.calculateCoordinates=function(){
  var julianDay2=julianDay-epoch;
  if(this.type===SATERITE) julianDay2=julianDay-DEAULT_EPOCH;
  var lofp=this.lofp0+this.lofp1*julianDay2;
  var lofan=this.lofan0+this.lofan1*julianDay2;
  var m=this.meanl-lofp+this.pinv*julianDay2;
  var eeh=0.5*eccentricAnomaly(m,this.eccen);
  var v=Math.PI;
  if(Math.cos(eeh)!==0.0){
    var tanv=Math.sqrt((1.0+this.eccen)/(1.0-this.eccen));
    v=2.0*Math.atan(tanv*Math.tan(eeh));
  }
  v+=lofp;
  var lens=this.sma*(1.0-this.eccen*Math.cos(2.0*eeh));
  var ss=Math.sin(v-lofan);
  var cinc=1.0-Math.cos(this.inc);
  this.p.set
    (lens*(Math.cos(v)+ss*Math.sin(lofan)*cinc),
     lens*(Math.sin(v)-ss*Math.cos(lofan)*cinc),
     lens*ss*Math.sin(this.inc));
};

// Ovf쐬
Planet.prototype.createOrbit=function(){
  var thpa=this.lofp0-this.lofan0;
  var ccpa=Math.cos(thpa),sspa=Math.sin(thpa);
  var cinc=1.0-Math.cos(this.inc),sinc=Math.sin(this.inc);
  var ccan=Math.cos(this.lofan0)*cinc,ssan=Math.sin(this.lofan0)*cinc;
  var ccp=Math.cos(this.lofp0),ssp=Math.sin(this.lofp0);
  var m11=ccp+sspa*ssan;
  var m12=-ssp+ccpa*ssan;
  var m21=ssp-sspa*ccan;
  var m22=ccp-ccpa*ccan;
  var m31=sspa*sinc;
  var m32=ccpa*sinc;
  var smaY=this.sma*Math.sqrt(1.0-this.eccen*this.eccen);
  var cc=1.0;
  var ss=0.0;
  var dtheta=2.0*Math.PI/ORBIT_VIEW_COUNT;
  var dc=Math.cos(dtheta);
  var ds=Math.sin(dtheta);
  var vCount=3*(ORBIT_VIEW_COUNT+1);
  var vertices=new Float32Array(vCount);
  for(var i=0;i<vCount;i+=3){
    var x0=this.sma*(cc-this.eccen);
    var y0=smaY*ss;
    vertices[i]=m11*x0+m12*y0;
    vertices[i+1]=m21*x0+m22*y0;
    vertices[i+2]=m31*x0+m32*y0;
    var cctemp=cc*dc-ss*ds;
    var sstemp=ss*dc+cc*ds;
    cc=cctemp;
    ss=sstemp;
  }
  var geometry=new THREE.BufferGeometry();
  geometry.addAttribute
    ('position',new THREE.BufferAttribute(vertices,3));
  this.orbit=new THREE.Line(geometry,ORBIT_MAT);
};

// fɐԓWʒuvZ
// p0 - n̉Wʒu
// eps - XΊp
Planet.prototype.calculateMEC=function(p0,eps){
  var epss=Math.sin(eps),epsc=Math.cos(eps);
  var dx=this.p.x,dy=this.p.y,dz=this.p.z;
  if(this.type!==SATERITE){
    dx-=p0.x;
    dy-=p0.y;
    dz-=p0.z;
  }
  var ty=dy*epsc-dz*epss,tz=dy*epss+dz*epsc;
  dy=ty;
  dz=tz;
  var dd=Math.sqrt(dx*dx+dy*dy+dz*dz);
  if(dd===0) return;
  this.my=Math.asin(dz/dd);
  this.mx=Math.atan2(dy,dx);
};

// f\Ԃ
Planet.prototype.toString=function(){
  return this.name;
};

// ̕\FԂ
// bv - Fw B-V
function colorIndexBV(bv){
  if(bv<=0.0){
    var r=Math.max(255+parseInt(382.5*bv),0);
    var g=Math.max(255+parseInt(127.75*bv),0);
    return ((r<<16)|(g<<8)|0xff).toString(16);
  }
  else if(bv<0.8){
    var b=255-parseInt(159.375*bv);
    return (0xffff00|b).toString(16);
  }
  else{
    var g2=Math.max(340-parseInt(106.25*bv),0);
    return (0xff007f|(g2<<8)).toString(16);
  }
}

// _̕\FԂ
// type - _̎
// vmag - 
function nebulaColor(type,vmag){
  if(type===GALAXY){
    return GALAXY_COLOR;
  }
  else if(type===BRINEB){
    var r=Math.min(parseInt(255*-25.5*vmag),255);
    return (r<<16).toString(16);
  }
  else{
    var c=Math.min(parseInt(255*-25.5*vmag),255);
    return ((c<<16)|(c<<8)|c).toString(16);
  }
}

// Newton @gpėSߓ_p߂
// m - ϋߓ_p
// eccen - S
function eccentricAnomaly(m,eccen){
  var ei=m+eccen*Math.sin(m);
  var mi=ei-eccen*Math.sin(ei);
  var dm=Math.abs(m-mi);
  while(dm>TOLERANCE){
    ei+=(m-mi)/(1.0-eccen*Math.cos(ei));
    mi=ei-eccen*Math.sin(ei);
    dm=Math.abs(m-mi);
  }
  return ei;
}

inherits(FixedStar,Star);
inherits(Planet,Star);
