//--------------------------------------------------------------------//
// f[^f
var StarsModel=function(){
  this.stars=[];		// PE_
  this.starsMap={};
  this.planets=[];		// f
  this.saterites=[];		// q
  this.constellations=[];	// 
  this.earth=null;		// n
  this.sky=null;		// wi
  this.shell=null;		// h[
};

// Pǉ
// star - P
StarsModel.prototype.addStar=function(star){
  this.stars.push(star);
  this.starsMap[star.id]=star;
};

// fǉ
// planet - f
StarsModel.prototype.addPlanet=function(planet){
  this.planets.push(planet);
  if(planet.type===SATERITE){
    this.saterites.push(planet);
  }
};

// nǉ
// earth - n
StarsModel.prototype.addEarth=function(earth){
  this.earth=earth;
  this.addPlanet(earth);
};

// ǉ
// constellation - 
StarsModel.prototype.addConstellation=function(constellation){
  this.constellations.push(constellation);
};

// QƂ鐯̂𗪍瑮iɕύX
StarsModel.prototype.setConstellationName=function(){
  var cMap={},i;
  for(i=0;i<this.constellations.length;i++){
    var cons=this.constellations[i];
    cMap[cons.shortName]=cons.genitive;
  }
  for(i=0;i<this.stars.length;i++){
    var value=cMap[this.stars[i].constellation];
    if(value!==undefined){
      this.stars[i].constellation=value;
    }
  }
};

// f̈ʒuvZ
StarsModel.prototype.calculateCoordinates=function(){
  var count=this.planets.length,i;
  for(i=0;i<count;i++){
    this.planets[i].calculateCoordinates();
  }
  for(i=0;i<count;i++){
    this.planets[i].calculateMEC(this.earth.p,this.earth.tilt);
  }
};

// f̕\ʒuݒ肷
StarsModel.prototype.setPlanetPosition=function(){
  var count=this.planets.length,i;
  for(i=0;i<count;i++){
    this.planets[i].calculateCoordinates();
  }
  for(i=0;i<count;i++){
    this.planets[i].calculateMEC(this.earth.p,this.earth.tilt);
    this.planets[i].setPosition();
  }
  this.setSkyColor();
};

// \IuWFNg쐬
StarsModel.prototype.createObjects=function(){
  var i;
  for(i=0;i<this.stars.length;i++){
    this.stars[i].createObject();
    viewModel.addObject(this.stars[i].obj);
  }
  for(i=0;i<this.planets.length;i++){
    this.planets[i].createObject();
    viewModel.addObject(this.planets[i].obj);
  }
  for(i=0;i<this.constellations.length;i++){
    this.constellations[i].createObject(this.starsMap);
    viewModel.addObject(this.constellations[i].obj);
    this.constellations[i].obj.visible=true;
  }
  var material=new THREE.MeshBasicMaterial({side:THREE.BackSide});
  this.sky=new THREE.Mesh(new THREE.SphereGeometry(7),material);
  viewModel.addObject(this.sky);
  material=new THREE.MeshBasicMaterial
    ({transparent:true,opacity:0.2,color:0x666699,side:THREE.BackSide});
  this.shell=new THREE.Mesh(new THREE.SphereGeometry(1,48,24),material);
  viewModel.addObject(this.shell);
};

// ̐Fݒ肷
StarsModel.prototype.setSkyColor=function(){
  var h=0;
  for(var i=0;i<this.planets.length;i++){
    var pl=this.planets[i];
    if(pl.type===SUN){
      h=pl.obj.position.dot(viewModel.top);
    }
  }
  if(h<-0.2){
    this.sky.material.color.set(0);
  }
  else if(h<0.0){
    var b=parseInt(1275*h+255);
    this.sky.material.color.set(b);
  }
  else if(h<0.2){
    var g=parseInt(1275*h);
    this.sky.material.color.set(0x0000ff|(g<<8));
  }
  else{
    this.sky.material.color.set(0x00ffff);
  }
};
