//--------------------------------------------------------------------//
// \f
// canvasId - \̈ID
var ViewModel=function(canvasId){
  this.canvasFrame=document.getElementById(canvasId);		// `t[
  this.renderer=new THREE.WebGLRenderer({antialias:true});	// _\
  if(!this.renderer){
    alert("three.js ̏Ɏs܂");
  }

  this.renderer.setSize(this.canvasFrame.clientWidth,
      	      	      	this.canvasFrame.clientHeight);
  this.renderer.setClearColor(0x000000,1);
  this.canvasFrame.appendChild(this.renderer.domElement);

  this.labelRenderer=new THREE.CSS2DRenderer();
  this.labelRenderer.setSize(this.canvasFrame.clientWidth,
      	      	      	     this.canvasFrame.clientHeight);
  this.labelRenderer.domElement.style.position='absolute';
  this.labelRenderer.domElement.style.top='0';
  this.labelRenderer.domElement.style.pointerEvents='none';
  this.canvasFrame.appendChild(this.labelRenderer.domElement);

  this.scene=new THREE.Scene();				// V[
  this.initLight();
  this.initCamera();
  this.receives=[];					// NbNΏ
  this.raycaster=new THREE.Raycaster();
  this.axis=null;
  this.sunHeight=0;					// z
  this.dirX=0;						// p
  this.dirY=0;
  this.zoomInv=1;					// k
  this.panX=0;						// `ʒu
  this.panY=0;
  this.rotCoef=Math.PI/this.canvasFrame.clientWidth;	// ]W
  this.zoomCoef=1/this.canvasFrame.clientHeight;	// gkW
  this.panCoef=1.2/this.canvasFrame.clientHeight;	// sړW
  this.pos=new THREE.Vector3();			// \ʒuxNg
  this.camProj=new THREE.Matrix4();		// J̍Wϊ}gbNX
  this.dirPlate=[textPlate('N'),textPlate('NE'),	// pv[g
      	      	 textPlate('E'),textPlate('SE'),
      	      	 textPlate('S'),textPlate('SW'),
      	      	 textPlate('W'),textPlate('NW')];
  for(var i=0;i<this.dirPlate.length;i++){
    this.scene.add(this.dirPlate[i]);
  }
  this.names={};				// ̕\v[g
  this.setLocale();
};

// 
ViewModel.prototype.initLight=function(){
// s
  this.directionalLight=new THREE.DirectionalLight(0xffffff,10);
  this.scene.add(this.directionalLight);
};

// J
ViewModel.prototype.initCamera=function(){
  this.top=new THREE.Vector3(0,0,1);
  this.target=new THREE.Vector3(1,0,0);

  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  this.vRange={l:-0.6*aspect,r:0.6*aspect,t:1.2,b:0};
  this.camera=new THREE.OrthographicCamera
    (this.vRange.l,this.vRange.r,this.vRange.t,this.vRange.b,0,1000);
  this.camera.position.set(0,0,0);
};

// }EXCxg
ViewModel.prototype.initMouseEvent=function(){
  var vm=this,i,mouse2=new THREE.Vector2();
  this.receives.length=0;
  for(i=0;i<starsModel.stars.length;i++){
    this.receives.push(starsModel.stars[i].obj);
  }
  for(i=0;i<starsModel.planets.length;i++){
    this.receives.push(starsModel.planets[i].obj);
  }
  var cfx=2/this.canvasFrame.clientWidth;
  var cfy=2/this.canvasFrame.clientHeight;

  this.canvasFrame.addEventListener('mousedown',viewMousePressed,false);
  this.canvasFrame.addEventListener('contextmenu',viewContextMenu,false);

// }EX{^̏s
  function viewMousePressed(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=e.buttons;
    mouse.set(e.pageX,e.pageY);
    document.addEventListener('mouseup',viewMouseReleased,false);
    document.addEventListener('mousemove',viewMouseMoved,false);
    var bcr=vm.canvasFrame.getBoundingClientRect();
    mouse2.set(cfx*(e.clientX-bcr.left)-1,
      	       -(cfy*(e.clientY-bcr.top)-1));
    vm.raycaster.setFromCamera(mouse2,vm.camera);
    var intersects=vm.raycaster.intersectObjects(vm.receives);
    if(intersects.length>0){
      var name=intersects[0].object.name;
      if(!(name in vm.names)){
      	vm.names[name]=textPlate(name);
      	vm.addObject(vm.names[name]);
      }
      vm.names[name].position.copy(intersects[0].point);
    }
    else{
      for(var key in vm.names){
      	vm.removeObject(vm.names[key]);
      	delete vm.names[key];
      }
    }
  }

// }EX{^𗣂̏s
  function viewMouseReleased(e){
    e.preventDefault();
    e.stopPropagation();
    pressedButtons=0;
    document.removeEventListener('mouseup',viewMouseReleased,false);
    document.removeEventListener('mousemove',viewMouseMoved,false);
  }

// }EX{^ړ̏s
  function viewMouseMoved(e){
    var moved=false;
// {^|]
    if(pressedButtons&0x1){
      vm.dirX+=vm.rotCoef*(e.pageX-mouse.x);
      vm.dirY+=vm.rotCoef*(e.pageY-mouse.y);
      if(vm.dirX<-Math.PI) vm.dirX+=2*Math.PI;
      if(vm.dirX>Math.PI)  vm.dirX-=2*Math.PI;
      vm.dirY=Math.max(Math.min(vm.dirY,0.45*Math.PI),0);
      moved=true;
    }
// {^|gEk
    if(pressedButtons&0x4){
      vm.zoomInv+=vm.zoomCoef*(e.pageY-mouse.y);
      vm.zoomInv=Math.max(Math.min(vm.zoomInv,2),0.5);
      moved=true;
    }
// E{^|sړ
    if(pressedButtons&0x2){
      vm.panX+=vm.panCoef*vm.zoomInv*(e.pageX-mouse.x);
      vm.panY+=vm.panCoef*vm.zoomInv*(mouse.y-e.pageY);
      vm.panX=Math.max(Math.min(vm.panX,1),-1);
      vm.panY=Math.max(Math.min(vm.panY,1.5),-0.4);
      moved=true;
    }
    if(moved){
      vm.setCamera();
      mouse.set(e.pageX,e.pageY);
    }
  }

// j[\}
  function viewContextMenu(e){
    e.preventDefault();
  }
};

// \ʒuݒ肷
ViewModel.prototype.setLocale=function(){
  var th=SIDEREAL0+DAY_RATIO*(julianDay-SIDEREAL_EPOCH);
  th=2.0*Math.PI*(th-Math.floor(th));
  var phy=TO_RADIAN*globe.y,cphy=Math.cos(phy);
  var topx=Math.cos(th)*cphy;
  var topy=Math.sin(th)*cphy;
  var topz=Math.sin(phy);
  this.top.set(topx,topy,topz);
  var tgx=-topx*topz,tgy=-topy*topz,tgz=1-topz*topz,tgp=Math.sqrt(tgz);
  if(tgp===0){
    this.target.set(1,0,0);
  }
  else{
    this.target.set(tgx/tgp,tgy/tgp,tgz/tgp);
  }
  this.camera.up.set(topx,topy,topz);
  var dir=this.target.clone();
  for(var i=0;i<this.dirPlate.length;i++){
    this.dirPlate[i].position.copy(dir);
    dir.applyAxisAngle(this.top,-0.25*Math.PI);
  }
  this.setCamera();
};

// \ʒu
ViewModel.prototype.initView=function(){
  this.dirX=0;
  this.dirY=0;
  this.zoomInv=1;
  this.panX=0;
  this.panY=0;
  this.setLocale();
};

// Jʒuݒ肷
ViewModel.prototype.setCamera=function(){
  var rot=new THREE.Vector3().crossVectors(this.target,this.top);
  var tgt=this.target.clone().applyAxisAngle(rot,this.dirY).
      	    applyAxisAngle(this.top,this.dirX);
  this.camera.lookAt(tgt);
  this.camera.left=this.zoomInv*(this.vRange.l-this.panX);
  this.camera.right=this.zoomInv*(this.vRange.r-this.panX);
  this.camera.top=this.zoomInv*(this.vRange.t-this.panY);
  this.camera.bottom=this.zoomInv*(this.vRange.b-this.panY);
  this.camera.updateProjectionMatrix();
  this.camera.updateMatrix();
  this.camera.updateMatrixWorld();
  this.camera.matrixWorldInverse.getInverse(this.camera.matrixWorld);
  this.directionalLight.position.set(-tgt.x,-tgt.y,-tgt.z);
  this.camProj.multiplyMatrices(this.camera.projectionMatrix,
      	      	      	      	this.camera.matrixWorldInverse);
  for(var i=0;i<this.dirPlate.length;i++){
    this.setPlateView(this.dirPlate[i]);
  }
  for(var key in this.names){
    this.setPlateView(this.names[key]);
  }
};

// v[g̕\ݒ
ViewModel.prototype.setPlateView=function(plate){
  this.pos.copy(plate.position).applyMatrix4(this.camProj);
  if((-1<=this.pos.z) && (this.pos.z<=1)){
    plate.element.style.display='inline';
  }
  else{
    plate.element.style.display='none';
  }
};

// \IuWFNgǉ
ViewModel.prototype.addObject=function(obj){
  this.scene.add(obj);
};

// \IuWFNg폜
ViewModel.prototype.removeObject=function(obj){
  this.scene.remove(obj);
};

// Wݒ肷
ViewModel.prototype.setAxis=function(){
  if(this.axis!==null){
    this.scene.remove(this.axis);
  }
  this.axis=new THREE.AxisHelper(0.2);
  this.axis.position.set(0,0,0);
  this.scene.add(this.axis);
};

// \XV
ViewModel.prototype.update=function(){
  this.renderer.render(this.scene,this.camera);
  this.labelRenderer.render(this.scene,this.camera);
};
